<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTVHWS.carrier ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTVHWS.carrier
 * @subpackage Arrays
 */
class ArrayOfTVHWS_carrier extends AbstractStructArrayBase
{
    /**
     * The TVHWS_carrier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TVHWS_carrier[]
     */
    public $TVHWS_carrier;
    /**
     * Constructor method for ArrayOfTVHWS.carrier
     * @uses ArrayOfTVHWS_carrier::setTVHWS_carrier()
     * @param \StructType\TVHWS_carrier[] $tVHWS_carrier
     */
    public function __construct(array $tVHWS_carrier = array())
    {
        $this
            ->setTVHWS_carrier($tVHWS_carrier);
    }
    /**
     * Get TVHWS_carrier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TVHWS_carrier[]|null
     */
    public function getTVHWS_carrier()
    {
        return isset($this->{'TVHWS.carrier'}) ? $this->{'TVHWS.carrier'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTVHWS_carrier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTVHWS_carrier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTVHWS_carrierForArrayConstraintsFromSetTVHWS_carrier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTVHWS_carrierTVHWS_carrierItem) {
            // validation for constraint: itemType
            if (!$arrayOfTVHWS_carrierTVHWS_carrierItem instanceof \StructType\TVHWS_carrier) {
                $invalidValues[] = is_object($arrayOfTVHWS_carrierTVHWS_carrierItem) ? get_class($arrayOfTVHWS_carrierTVHWS_carrierItem) : sprintf('%s(%s)', gettype($arrayOfTVHWS_carrierTVHWS_carrierItem), var_export($arrayOfTVHWS_carrierTVHWS_carrierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TVHWS_carrier property can only contain items of type \StructType\TVHWS_carrier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TVHWS_carrier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TVHWS_carrier[] $tVHWS_carrier
     * @return \ArrayType\ArrayOfTVHWS_carrier
     */
    public function setTVHWS_carrier(array $tVHWS_carrier = array())
    {
        // validation for constraint: array
        if ('' !== ($tVHWS_carrierArrayErrorMessage = self::validateTVHWS_carrierForArrayConstraintsFromSetTVHWS_carrier($tVHWS_carrier))) {
            throw new \InvalidArgumentException($tVHWS_carrierArrayErrorMessage, __LINE__);
        }
        if (is_null($tVHWS_carrier) || (is_array($tVHWS_carrier) && empty($tVHWS_carrier))) {
            unset($this->TVHWS_carrier, $this->{'TVHWS.carrier'});
        } else {
            $this->TVHWS_carrier = $this->{'TVHWS.carrier'} = $tVHWS_carrier;
        }
        return $this;
    }
    /**
     * Add item to TVHWS_carrier value
     * @throws \InvalidArgumentException
     * @param \StructType\TVHWS_carrier $item
     * @return \ArrayType\ArrayOfTVHWS_carrier
     */
    public function addToTVHWS_carrier(\StructType\TVHWS_carrier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TVHWS_carrier) {
            throw new \InvalidArgumentException(sprintf('The TVHWS_carrier property can only contain items of type \StructType\TVHWS_carrier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TVHWS_carrier[] = $this->{'TVHWS.carrier'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TVHWS_carrier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TVHWS_carrier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TVHWS_carrier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TVHWS_carrier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TVHWS_carrier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TVHWS.carrier
     */
    public function getAttributeName()
    {
        return 'TVHWS.carrier';
    }
}
