<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTVHWS.item_response ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTVHWS.item_response
 * @subpackage Arrays
 */
class ArrayOfTVHWS_item_response extends AbstractStructArrayBase
{
    /**
     * The TVHWS_item_response
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TVHWS_item_response[]
     */
    public $TVHWS_item_response;
    /**
     * Constructor method for ArrayOfTVHWS.item_response
     * @uses ArrayOfTVHWS_item_response::setTVHWS_item_response()
     * @param \StructType\TVHWS_item_response[] $tVHWS_item_response
     */
    public function __construct(array $tVHWS_item_response = array())
    {
        $this
            ->setTVHWS_item_response($tVHWS_item_response);
    }
    /**
     * Get TVHWS_item_response value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TVHWS_item_response[]|null
     */
    public function getTVHWS_item_response()
    {
        return isset($this->{'TVHWS.item_response'}) ? $this->{'TVHWS.item_response'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTVHWS_item_response method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTVHWS_item_response method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTVHWS_item_responseForArrayConstraintsFromSetTVHWS_item_response(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTVHWS_item_responseTVHWS_item_responseItem) {
            // validation for constraint: itemType
            if (!$arrayOfTVHWS_item_responseTVHWS_item_responseItem instanceof \StructType\TVHWS_item_response) {
                $invalidValues[] = is_object($arrayOfTVHWS_item_responseTVHWS_item_responseItem) ? get_class($arrayOfTVHWS_item_responseTVHWS_item_responseItem) : sprintf('%s(%s)', gettype($arrayOfTVHWS_item_responseTVHWS_item_responseItem), var_export($arrayOfTVHWS_item_responseTVHWS_item_responseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TVHWS_item_response property can only contain items of type \StructType\TVHWS_item_response, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TVHWS_item_response value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TVHWS_item_response[] $tVHWS_item_response
     * @return \ArrayType\ArrayOfTVHWS_item_response
     */
    public function setTVHWS_item_response(array $tVHWS_item_response = array())
    {
        // validation for constraint: array
        if ('' !== ($tVHWS_item_responseArrayErrorMessage = self::validateTVHWS_item_responseForArrayConstraintsFromSetTVHWS_item_response($tVHWS_item_response))) {
            throw new \InvalidArgumentException($tVHWS_item_responseArrayErrorMessage, __LINE__);
        }
        if (is_null($tVHWS_item_response) || (is_array($tVHWS_item_response) && empty($tVHWS_item_response))) {
            unset($this->TVHWS_item_response, $this->{'TVHWS.item_response'});
        } else {
            $this->TVHWS_item_response = $this->{'TVHWS.item_response'} = $tVHWS_item_response;
        }
        return $this;
    }
    /**
     * Add item to TVHWS_item_response value
     * @throws \InvalidArgumentException
     * @param \StructType\TVHWS_item_response $item
     * @return \ArrayType\ArrayOfTVHWS_item_response
     */
    public function addToTVHWS_item_response(\StructType\TVHWS_item_response $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TVHWS_item_response) {
            throw new \InvalidArgumentException(sprintf('The TVHWS_item_response property can only contain items of type \StructType\TVHWS_item_response, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TVHWS_item_response[] = $this->{'TVHWS.item_response'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TVHWS_item_response|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TVHWS_item_response|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TVHWS_item_response|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TVHWS_item_response|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TVHWS_item_response|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TVHWS.item_response
     */
    public function getAttributeName()
    {
        return 'TVHWS.item_response';
    }
}
