<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTVHWS.transport ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTVHWS.transport
 * @subpackage Arrays
 */
class ArrayOfTVHWS_transport extends AbstractStructArrayBase
{
    /**
     * The TVHWS_transport
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TVHWS_transport[]
     */
    public $TVHWS_transport;
    /**
     * Constructor method for ArrayOfTVHWS.transport
     * @uses ArrayOfTVHWS_transport::setTVHWS_transport()
     * @param \StructType\TVHWS_transport[] $tVHWS_transport
     */
    public function __construct(array $tVHWS_transport = array())
    {
        $this
            ->setTVHWS_transport($tVHWS_transport);
    }
    /**
     * Get TVHWS_transport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TVHWS_transport[]|null
     */
    public function getTVHWS_transport()
    {
        return isset($this->{'TVHWS.transport'}) ? $this->{'TVHWS.transport'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTVHWS_transport method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTVHWS_transport method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTVHWS_transportForArrayConstraintsFromSetTVHWS_transport(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTVHWS_transportTVHWS_transportItem) {
            // validation for constraint: itemType
            if (!$arrayOfTVHWS_transportTVHWS_transportItem instanceof \StructType\TVHWS_transport) {
                $invalidValues[] = is_object($arrayOfTVHWS_transportTVHWS_transportItem) ? get_class($arrayOfTVHWS_transportTVHWS_transportItem) : sprintf('%s(%s)', gettype($arrayOfTVHWS_transportTVHWS_transportItem), var_export($arrayOfTVHWS_transportTVHWS_transportItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TVHWS_transport property can only contain items of type \StructType\TVHWS_transport, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TVHWS_transport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TVHWS_transport[] $tVHWS_transport
     * @return \ArrayType\ArrayOfTVHWS_transport
     */
    public function setTVHWS_transport(array $tVHWS_transport = array())
    {
        // validation for constraint: array
        if ('' !== ($tVHWS_transportArrayErrorMessage = self::validateTVHWS_transportForArrayConstraintsFromSetTVHWS_transport($tVHWS_transport))) {
            throw new \InvalidArgumentException($tVHWS_transportArrayErrorMessage, __LINE__);
        }
        if (is_null($tVHWS_transport) || (is_array($tVHWS_transport) && empty($tVHWS_transport))) {
            unset($this->TVHWS_transport, $this->{'TVHWS.transport'});
        } else {
            $this->TVHWS_transport = $this->{'TVHWS.transport'} = $tVHWS_transport;
        }
        return $this;
    }
    /**
     * Add item to TVHWS_transport value
     * @throws \InvalidArgumentException
     * @param \StructType\TVHWS_transport $item
     * @return \ArrayType\ArrayOfTVHWS_transport
     */
    public function addToTVHWS_transport(\StructType\TVHWS_transport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TVHWS_transport) {
            throw new \InvalidArgumentException(sprintf('The TVHWS_transport property can only contain items of type \StructType\TVHWS_transport, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TVHWS_transport[] = $this->{'TVHWS.transport'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TVHWS_transport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TVHWS_transport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TVHWS_transport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TVHWS_transport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TVHWS_transport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TVHWS.transport
     */
    public function getAttributeName()
    {
        return 'TVHWS.transport';
    }
}
