<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TVHWS.address StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TVHWS.address
 * @subpackage Structs
 */
class TVHWS_address extends AbstractStructBase
{
    /**
     * The address1
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $address1;
    /**
     * The address2
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $address2;
    /**
     * The address3
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $address3;
    /**
     * The attn
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $attn;
    /**
     * The city
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $city;
    /**
     * The code
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $code;
    /**
     * The countrycode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $countrycode;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $name;
    /**
     * The postalcode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $postalcode;
    /**
     * The state
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $state;
    /**
     * Constructor method for TVHWS.address
     * @uses TVHWS_address::setAddress1()
     * @uses TVHWS_address::setAddress2()
     * @uses TVHWS_address::setAddress3()
     * @uses TVHWS_address::setAttn()
     * @uses TVHWS_address::setCity()
     * @uses TVHWS_address::setCode()
     * @uses TVHWS_address::setCountrycode()
     * @uses TVHWS_address::setName()
     * @uses TVHWS_address::setPostalcode()
     * @uses TVHWS_address::setState()
     * @param string $address1
     * @param string $address2
     * @param string $address3
     * @param string $attn
     * @param string $city
     * @param string $code
     * @param string $countrycode
     * @param string $name
     * @param string $postalcode
     * @param string $state
     */
    public function __construct($address1 = null, $address2 = null, $address3 = null, $attn = null, $city = null, $code = null, $countrycode = null, $name = null, $postalcode = null, $state = null)
    {
        $this
            ->setAddress1($address1)
            ->setAddress2($address2)
            ->setAddress3($address3)
            ->setAttn($attn)
            ->setCity($city)
            ->setCode($code)
            ->setCountrycode($countrycode)
            ->setName($name)
            ->setPostalcode($postalcode)
            ->setState($state);
    }
    /**
     * Get address1 value
     * @return string|null
     */
    public function getAddress1()
    {
        return $this->address1;
    }
    /**
     * Set address1 value
     * @param string $address1
     * @return \StructType\TVHWS_address
     */
    public function setAddress1($address1 = null)
    {
        // validation for constraint: string
        if (!is_null($address1) && !is_string($address1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address1, true), gettype($address1)), __LINE__);
        }
        $this->address1 = $address1;
        return $this;
    }
    /**
     * Get address2 value
     * @return string|null
     */
    public function getAddress2()
    {
        return $this->address2;
    }
    /**
     * Set address2 value
     * @param string $address2
     * @return \StructType\TVHWS_address
     */
    public function setAddress2($address2 = null)
    {
        // validation for constraint: string
        if (!is_null($address2) && !is_string($address2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address2, true), gettype($address2)), __LINE__);
        }
        $this->address2 = $address2;
        return $this;
    }
    /**
     * Get address3 value
     * @return string|null
     */
    public function getAddress3()
    {
        return $this->address3;
    }
    /**
     * Set address3 value
     * @param string $address3
     * @return \StructType\TVHWS_address
     */
    public function setAddress3($address3 = null)
    {
        // validation for constraint: string
        if (!is_null($address3) && !is_string($address3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address3, true), gettype($address3)), __LINE__);
        }
        $this->address3 = $address3;
        return $this;
    }
    /**
     * Get attn value
     * @return string|null
     */
    public function getAttn()
    {
        return $this->attn;
    }
    /**
     * Set attn value
     * @param string $attn
     * @return \StructType\TVHWS_address
     */
    public function setAttn($attn = null)
    {
        // validation for constraint: string
        if (!is_null($attn) && !is_string($attn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($attn, true), gettype($attn)), __LINE__);
        }
        $this->attn = $attn;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \StructType\TVHWS_address
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \StructType\TVHWS_address
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get countrycode value
     * @return string|null
     */
    public function getCountrycode()
    {
        return $this->countrycode;
    }
    /**
     * Set countrycode value
     * @param string $countrycode
     * @return \StructType\TVHWS_address
     */
    public function setCountrycode($countrycode = null)
    {
        // validation for constraint: string
        if (!is_null($countrycode) && !is_string($countrycode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countrycode, true), gettype($countrycode)), __LINE__);
        }
        $this->countrycode = $countrycode;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\TVHWS_address
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get postalcode value
     * @return string|null
     */
    public function getPostalcode()
    {
        return $this->postalcode;
    }
    /**
     * Set postalcode value
     * @param string $postalcode
     * @return \StructType\TVHWS_address
     */
    public function setPostalcode($postalcode = null)
    {
        // validation for constraint: string
        if (!is_null($postalcode) && !is_string($postalcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postalcode, true), gettype($postalcode)), __LINE__);
        }
        $this->postalcode = $postalcode;
        return $this;
    }
    /**
     * Get state value
     * @return string|null
     */
    public function getState()
    {
        return $this->state;
    }
    /**
     * Set state value
     * @param string $state
     * @return \StructType\TVHWS_address
     */
    public function setState($state = null)
    {
        // validation for constraint: string
        if (!is_null($state) && !is_string($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($state, true), gettype($state)), __LINE__);
        }
        $this->state = $state;
        return $this;
    }
}
