<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TVHWS.item_request StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TVHWS.item_request
 * @subpackage Structs
 */
class TVHWS_item_request extends AbstractStructBase
{
    /**
     * The id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $id;
    /**
     * The itemnumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $itemnumber;
    /**
     * The quantity
     * @var int
     */
    public $quantity;
    /**
     * The reference
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $reference;
    /**
     * The wh
     * @var int
     */
    public $wh;
    /**
     * Constructor method for TVHWS.item_request
     * @uses TVHWS_item_request::setId()
     * @uses TVHWS_item_request::setItemnumber()
     * @uses TVHWS_item_request::setQuantity()
     * @uses TVHWS_item_request::setReference()
     * @uses TVHWS_item_request::setWh()
     * @param string $id
     * @param string $itemnumber
     * @param int $quantity
     * @param string $reference
     * @param int $wh
     */
    public function __construct($id = null, $itemnumber = null, $quantity = null, $reference = null, $wh = null)
    {
        $this
            ->setId($id)
            ->setItemnumber($itemnumber)
            ->setQuantity($quantity)
            ->setReference($reference)
            ->setWh($wh);
    }
    /**
     * Get id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getId()
    {
        return isset($this->id) ? $this->id : null;
    }
    /**
     * Set id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $id
     * @return \StructType\TVHWS_item_request
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        if (is_null($id) || (is_array($id) && empty($id))) {
            unset($this->id);
        } else {
            $this->id = $id;
        }
        return $this;
    }
    /**
     * Get itemnumber value
     * @return string|null
     */
    public function getItemnumber()
    {
        return $this->itemnumber;
    }
    /**
     * Set itemnumber value
     * @param string $itemnumber
     * @return \StructType\TVHWS_item_request
     */
    public function setItemnumber($itemnumber = null)
    {
        // validation for constraint: string
        if (!is_null($itemnumber) && !is_string($itemnumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemnumber, true), gettype($itemnumber)), __LINE__);
        }
        $this->itemnumber = $itemnumber;
        return $this;
    }
    /**
     * Get quantity value
     * @return int|null
     */
    public function getQuantity()
    {
        return $this->quantity;
    }
    /**
     * Set quantity value
     * @param int $quantity
     * @return \StructType\TVHWS_item_request
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: int
        if (!is_null($quantity) && !(is_int($quantity) || ctype_digit($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->quantity = $quantity;
        return $this;
    }
    /**
     * Get reference value
     * @return string|null
     */
    public function getReference()
    {
        return $this->reference;
    }
    /**
     * Set reference value
     * @param string $reference
     * @return \StructType\TVHWS_item_request
     */
    public function setReference($reference = null)
    {
        // validation for constraint: string
        if (!is_null($reference) && !is_string($reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reference, true), gettype($reference)), __LINE__);
        }
        $this->reference = $reference;
        return $this;
    }
    /**
     * Get wh value
     * @return int|null
     */
    public function getWh()
    {
        return $this->wh;
    }
    /**
     * Set wh value
     * @param int $wh
     * @return \StructType\TVHWS_item_request
     */
    public function setWh($wh = null)
    {
        // validation for constraint: int
        if (!is_null($wh) && !(is_int($wh) || ctype_digit($wh))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($wh, true), gettype($wh)), __LINE__);
        }
        $this->wh = $wh;
        return $this;
    }
}
