<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TVHWS.order_info StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TVHWS.order_info
 * @subpackage Structs
 */
class TVHWS_order_info extends AbstractStructBase
{
    /**
     * The error
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\TVHWS_error
     */
    public $error;
    /**
     * The items
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfTVHWS_item_response
     */
    public $items;
    /**
     * The orderid
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $orderid;
    /**
     * The wh
     * @var int
     */
    public $wh;
    /**
     * Constructor method for TVHWS.order_info
     * @uses TVHWS_order_info::setError()
     * @uses TVHWS_order_info::setItems()
     * @uses TVHWS_order_info::setOrderid()
     * @uses TVHWS_order_info::setWh()
     * @param \StructType\TVHWS_error $error
     * @param \ArrayType\ArrayOfTVHWS_item_response $items
     * @param string $orderid
     * @param int $wh
     */
    public function __construct(\StructType\TVHWS_error $error = null, \ArrayType\ArrayOfTVHWS_item_response $items = null, $orderid = null, $wh = null)
    {
        $this
            ->setError($error)
            ->setItems($items)
            ->setOrderid($orderid)
            ->setWh($wh);
    }
    /**
     * Get error value
     * @return \StructType\TVHWS_error|null
     */
    public function getError()
    {
        return $this->error;
    }
    /**
     * Set error value
     * @param \StructType\TVHWS_error $error
     * @return \StructType\TVHWS_order_info
     */
    public function setError(\StructType\TVHWS_error $error = null)
    {
        $this->error = $error;
        return $this;
    }
    /**
     * Get items value
     * @return \ArrayType\ArrayOfTVHWS_item_response|null
     */
    public function getItems()
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param \ArrayType\ArrayOfTVHWS_item_response $items
     * @return \StructType\TVHWS_order_info
     */
    public function setItems(\ArrayType\ArrayOfTVHWS_item_response $items = null)
    {
        $this->items = $items;
        return $this;
    }
    /**
     * Get orderid value
     * @return string|null
     */
    public function getOrderid()
    {
        return $this->orderid;
    }
    /**
     * Set orderid value
     * @param string $orderid
     * @return \StructType\TVHWS_order_info
     */
    public function setOrderid($orderid = null)
    {
        // validation for constraint: string
        if (!is_null($orderid) && !is_string($orderid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($orderid, true), gettype($orderid)), __LINE__);
        }
        $this->orderid = $orderid;
        return $this;
    }
    /**
     * Get wh value
     * @return int|null
     */
    public function getWh()
    {
        return $this->wh;
    }
    /**
     * Set wh value
     * @param int $wh
     * @return \StructType\TVHWS_order_info
     */
    public function setWh($wh = null)
    {
        // validation for constraint: int
        if (!is_null($wh) && !(is_int($wh) || ctype_digit($wh))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($wh, true), gettype($wh)), __LINE__);
        }
        $this->wh = $wh;
        return $this;
    }
}
