<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TVHWS.order_request StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TVHWS.order_request
 * @subpackage Structs
 */
class TVHWS_order_request extends AbstractStructBase
{
    /**
     * The carriers
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfTVHWS_carrier
     */
    public $carriers;
    /**
     * The comments
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $comments;
    /**
     * The contact
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $contact;
    /**
     * The hubpickup
     * @var bool
     */
    public $hubpickup;
    /**
     * The items
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfTVHWS_item_request
     */
    public $items;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $name;
    /**
     * The passport
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\TVHWS_passport
     */
    public $passport;
    /**
     * The shipdate
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $shipdate;
    /**
     * The shiptoaddress
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\TVHWS_address
     */
    public $shiptoaddress;
    /**
     * Constructor method for TVHWS.order_request
     * @uses TVHWS_order_request::setCarriers()
     * @uses TVHWS_order_request::setComments()
     * @uses TVHWS_order_request::setContact()
     * @uses TVHWS_order_request::setHubpickup()
     * @uses TVHWS_order_request::setItems()
     * @uses TVHWS_order_request::setName()
     * @uses TVHWS_order_request::setPassport()
     * @uses TVHWS_order_request::setShipdate()
     * @uses TVHWS_order_request::setShiptoaddress()
     * @param \ArrayType\ArrayOfTVHWS_carrier $carriers
     * @param string $comments
     * @param string $contact
     * @param bool $hubpickup
     * @param \ArrayType\ArrayOfTVHWS_item_request $items
     * @param string $name
     * @param \StructType\TVHWS_passport $passport
     * @param string $shipdate
     * @param \StructType\TVHWS_address $shiptoaddress
     */
    public function __construct(\ArrayType\ArrayOfTVHWS_carrier $carriers = null, $comments = null, $contact = null, $hubpickup = null, \ArrayType\ArrayOfTVHWS_item_request $items = null, $name = null, \StructType\TVHWS_passport $passport = null, $shipdate = null, \StructType\TVHWS_address $shiptoaddress = null)
    {
        $this
            ->setCarriers($carriers)
            ->setComments($comments)
            ->setContact($contact)
            ->setHubpickup($hubpickup)
            ->setItems($items)
            ->setName($name)
            ->setPassport($passport)
            ->setShipdate($shipdate)
            ->setShiptoaddress($shiptoaddress);
    }
    /**
     * Get carriers value
     * @return \ArrayType\ArrayOfTVHWS_carrier|null
     */
    public function getCarriers()
    {
        return $this->carriers;
    }
    /**
     * Set carriers value
     * @param \ArrayType\ArrayOfTVHWS_carrier $carriers
     * @return \StructType\TVHWS_order_request
     */
    public function setCarriers(\ArrayType\ArrayOfTVHWS_carrier $carriers = null)
    {
        $this->carriers = $carriers;
        return $this;
    }
    /**
     * Get comments value
     * @return string|null
     */
    public function getComments()
    {
        return $this->comments;
    }
    /**
     * Set comments value
     * @param string $comments
     * @return \StructType\TVHWS_order_request
     */
    public function setComments($comments = null)
    {
        // validation for constraint: string
        if (!is_null($comments) && !is_string($comments)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comments, true), gettype($comments)), __LINE__);
        }
        $this->comments = $comments;
        return $this;
    }
    /**
     * Get contact value
     * @return string|null
     */
    public function getContact()
    {
        return $this->contact;
    }
    /**
     * Set contact value
     * @param string $contact
     * @return \StructType\TVHWS_order_request
     */
    public function setContact($contact = null)
    {
        // validation for constraint: string
        if (!is_null($contact) && !is_string($contact)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contact, true), gettype($contact)), __LINE__);
        }
        $this->contact = $contact;
        return $this;
    }
    /**
     * Get hubpickup value
     * @return bool|null
     */
    public function getHubpickup()
    {
        return $this->hubpickup;
    }
    /**
     * Set hubpickup value
     * @param bool $hubpickup
     * @return \StructType\TVHWS_order_request
     */
    public function setHubpickup($hubpickup = null)
    {
        // validation for constraint: boolean
        if (!is_null($hubpickup) && !is_bool($hubpickup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($hubpickup, true), gettype($hubpickup)), __LINE__);
        }
        $this->hubpickup = $hubpickup;
        return $this;
    }
    /**
     * Get items value
     * @return \ArrayType\ArrayOfTVHWS_item_request|null
     */
    public function getItems()
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param \ArrayType\ArrayOfTVHWS_item_request $items
     * @return \StructType\TVHWS_order_request
     */
    public function setItems(\ArrayType\ArrayOfTVHWS_item_request $items = null)
    {
        $this->items = $items;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\TVHWS_order_request
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get passport value
     * @return \StructType\TVHWS_passport|null
     */
    public function getPassport()
    {
        return $this->passport;
    }
    /**
     * Set passport value
     * @param \StructType\TVHWS_passport $passport
     * @return \StructType\TVHWS_order_request
     */
    public function setPassport(\StructType\TVHWS_passport $passport = null)
    {
        $this->passport = $passport;
        return $this;
    }
    /**
     * Get shipdate value
     * @return string|null
     */
    public function getShipdate()
    {
        return $this->shipdate;
    }
    /**
     * Set shipdate value
     * @param string $shipdate
     * @return \StructType\TVHWS_order_request
     */
    public function setShipdate($shipdate = null)
    {
        // validation for constraint: string
        if (!is_null($shipdate) && !is_string($shipdate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shipdate, true), gettype($shipdate)), __LINE__);
        }
        $this->shipdate = $shipdate;
        return $this;
    }
    /**
     * Get shiptoaddress value
     * @return \StructType\TVHWS_address|null
     */
    public function getShiptoaddress()
    {
        return $this->shiptoaddress;
    }
    /**
     * Set shiptoaddress value
     * @param \StructType\TVHWS_address $shiptoaddress
     * @return \StructType\TVHWS_order_request
     */
    public function setShiptoaddress(\StructType\TVHWS_address $shiptoaddress = null)
    {
        $this->shiptoaddress = $shiptoaddress;
        return $this;
    }
}
